/*
    Copyright (C) 1995 1996 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include "config.h"
/* this was stolen from some GNU source. May have been libiberty */

/*
AUTO_NEED HEADER memory.h
AUTO_NEED MACRO AC_HEADER_STDC
*/

#if STDC_HEADERS
#  include <stdarg.h>
#  define VA_START(args, lastarg) va_start(args, lastarg)
#else
#  include <varargs.h>
#  define VA_START(args, lastarg) va_start(args)
#endif

#if !defined(STDC_HEADERS) && defined(HAVE_MEMORY_H)
#  include <memory.h>
#endif
#if defined(STDC_HEADERS)
#  include <stdlib.h>
#endif

#ifndef NULL
#  ifdef STDC_HEADERS
#    include <stddef.h>
#  else
#    define NULL 0
#  endif
#endif

char *
#if defined(VA_START) && defined(STDC_HEADERS)
concat (const char *first, ...)
#else
concat (first, va_alist)
	const char *first;
    va_dcl
#endif
{
	int length;
	char *newstr;
	char *end;
	const char *arg;
	va_list args;

	/* First compute the size of the result and get sufficient memory. */

	VA_START (args, first);

	if (first == NULL)
		length = 0;
	else {
		length = strlen (first);
		while ((arg = va_arg (args, const char *)) != NULL)
			length += strlen (arg);
	}
	va_end (args);

	newstr = (char *) malloc (length + 1);
	if (!newstr)
		return NULL;

	/* Now copy the individual pieces to the result string. */

	if (newstr != NULL) {
		VA_START (args, first);
		end = newstr;
		if (first != NULL) {
			arg = first;
			while (*arg)
				*end++ = *arg++;
			while ((arg = va_arg (args, const char *)) != NULL) {
				while (*arg)
					*end++ = *arg++;
			}
		}
		*end = '\0';
		va_end (args);
	}

	return (newstr);
}

