#ifndef MAUSCONLIB_H1
#define MAUSCONLIB_H1

#include "mausconsys.h"
#include "error.h"
#include "entumlauten.h"
#include "mtzeit.h"
#include "xread.h"
#include "xwrite.h"
#include "lockfile.h"
#include "file_copy.h"

#ifndef HAVE_STRUPR
	/* could be defined in string.h */
	char *strupr (char *s);
#endif
#ifndef HAVE_STRLWR
	/* could be defined in string.h */
	char *strlwr (char *s);
#endif
#if !defined(HAVE_STRCASECMP) && defined(HAVE_STRICMP)
#  define strcasecmp stricmp
#endif
#if !defined(HAVE_STRNCASECMP) && defined(HAVE_STRNICMP)
#  define strncasecmp strnicmp
#endif

/* sock.c */
/* der ifdef erspart die Notwendigkeit, stdio.h in jedem Modul zu includen,
 * da diese Headerdatei includen will */
#ifdef _IOLBF
 BOOLEAN fopen_service (const char *servicename, const char *host,
     FILE **fin, FILE **fout, char **errtext);
#endif
int open_service (const char *servicename, const char *host, char **errtext);

/* rfc.c */
char * rfc_getword (char *rpos, char **nextpos);

/* crc.c */
ULONG crc32ansi(const char *puffer,ULONG laenge);

size_t xread(int fd, void *data, size_t count);
size_t xwrite(int fd, const void *data, size_t count);
size_t xwrite_tty(int fd, const char *data, size_t count);
    /* "void * vp" is "struct iovec *vp" */
int xwritev (int fd, void *vp, int vpcount);


#define XNULLCHECK(ptr) \
	do { if (!(ptr)) \
		error_at_line(1,0,__FILE__, __LINE__, "out of memory"); \
	} while(0)

char *concat (const char *first,...);
void *xmalloc (size_t n);
void *xrealloc (void *, size_t n);
void *mauscon_xcalloc (size_t, size_t);
char *mauscon_xstrdup (const char *);

#define XMALLOC(x)    xmalloc(x)
#define XSTRDUP(x)    mauscon_xstrdup(x)
#define XREALLOC(x,y) xrealloc(x,y)
#define XCALLOC(x,y)  mauscon_xcalloc(x,y)

#if __STDC__
extern int asprintf (char **, const char *, ...);
#else
extern int asprintf ();
#endif

#endif
