/* MausConnect: Nachrichtenformatskonverter fuer das MausNet
   Copyright (C) 1992 1993 1994 1995 Michael Kraehe, Uwe Ohse

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   lib.c: Allgemeine Hilfsfunktionen.
*/

#include "mausconsys.h"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
#include <fnmatch.h>
#include <errno.h>
#include <unistd.h>
#include <syslog.h>

#include "mauscon.h"
#include "mausconlib.h"

int
is_allowed (const char *sender)
{
	char lcsender[1024];
	char *p;
	mc_list_t *akt;

	for (p=lcsender; *sender; sender++)
		*p++=tolower(*sender);
	*p='\0';

	if (!strhalfcasecmp(opts.mailuserdomain,lcsender))
		return 1;

	akt=opts.allowed;
	while (akt && akt->data)
	{
		/* naechster Versuch */
		if (!fnmatch (akt->data, lcsender, FNM_CASEFOLD))
			return 1;
		akt=akt->next;
	}
	return 0;
}

int parse_bool(char *s)
{
    char c=tolower(*s);
    if (c=='y' || c=='j' || c=='t')
        return 1;
    else if (c=='n' || c=='f')
        return 0;
    else
        return (strtol(s,NULL,10)!=0);
}

FILE *
xfopen(const char *fname, const char *mode)
{
	FILE *f;
	f=fopen(fname,mode);
	if (!f)
	{
		/* es knnte jemand an der Datei herumbasteln, z.B. 
		 * mv datei old
		 * mv neu datei
		 */
		sleep(2);
		f=fopen(fname,mode);
	}
	if (!f)
	{
		static BOOLEAN no_recurse=FALSE;
		if (no_recurse)
			fprintf(stderr,_("cannot open %s: %s\n"),fname,strerror(errno));
		else
		{
			no_recurse=TRUE;
			log(LOG_ERR,_("cannot open %s: %s"),fname,strerror(errno));
		}
		exit (1);
	}
	return f;
}	

