/* maus.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef MAUS_H
#define MAUS_H

#include "metamsg.h"

typedef struct infoliststruct
{
	struct infoliststruct *next;
	char *kuerzel;   /* Kuerzel des Infofiles */
	char *kurztext;  /* Infozeile ber das Infofile */
	long last_crc;   /* letzte CRC des Infofiles */
	long pause;      /* Erst nach ... Tagen wieder bestellen */
	time_t last_date;/* Letzte Ankunft des Infofiles */
	short needs_crc; /* braucht das Infofile eine CRC? */
	short subscribed;/* bestellt? */
		/* Ein diff zwischen der neuen Version des Infofiles und der
		 * alten als Mail versenden? (an opts.mailuser)
		 */
	short send_diff;
	short send_mail; /* Das Infofile als Mail senden? */
	char *cmd;       /* bei Erhalt auszufhrendes Kommando */
} minfo_t;

/* MausNet-spezifische Funktionen */


char maus_get_tauschflag(char *s,char flag);


/* Libraryfunktionen rund um die Infofiles */
int info_read_list(void);
int info_write_list(void);
minfo_t *info_get_anker(void);
void info_add_new(minfo_t *);
void info_modified(minfo_t *);
void info_new_crc(char *kuerzel,long new_crc);
minfo_t *info_find(char *kuerzel);
void info_work_new_infofile(metamsg_t *meta, minfo_t *info);

#endif
