/* metamsg.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef METAMSG_H
#define METAMSG_H

#ifndef __C2MAN__
#include <time.h>
#endif

typedef struct metaliststruct
{
	char *text; /* data */
	char *ext;  /* extension */
	struct metaliststruct *next;
} metalist_t;

typedef struct metamsg
{
	/* Ist es Mail oder News? */
	int is_mail;
	/* Envelope der Nachricht, nur bei MAIL */
	char *     env_from;       /* physikalischer Absender */
	char *     env_to;         /* Zieladresse dieser Nachricht */
	/* Headerangaben */
	metalist_t *head_to;         /* Empfaenger */
	metalist_t *head_from;       /* Absenderadresse + -name */
	metalist_t *reply_to;        /* Empfnger einer Antwort (adresse+name) */
	metalist_t *sender;          /* tatschlicher Absender (adresse+name) */

	metalist_t *newsgroups;      /* Liste der Newsgroups */
	metalist_t *followup_to;     /* Liste der Followup-Groups */

	/* Message-ID */
	char *message_id;
	char *maus_id;               /* ID im MausNet */
	char *maus_special_id;       /* ITG, LOG, HEAD, ... */
	char *transfer_id;           /* Uebergangs-ID zwischen User und MAUS */
	metalist_t *references;      /* Usenetreihenfolge! */

	/* Sonstige wichtige Headerzeilen */
	struct tm * tm_date;
	char *distribution;
	char *subject;

	char *maus_status;

	char *also_control;
	char *approved;
	char *content_type;
	char *content_transfer_encoding;
	char *content_description;
	char *content_id;
	char *control;
	char *mime_version;
	char *received;
	struct tm *tm_expires;
	char *keywords;
	char *organization;
	char *path;
	char *summary;
	char *supersedes;
	char *comments;
	char *x_gateway; /* MausConnect blah fasel */
	char *x_format;  /* Usprungsformat der Nachricht */
	char *x_error;   /* Fehlermeldungen */
	char *x_mailer;  /* Angabe der Software des Ursprungssystems */
	metalist_t *return_receipt_to;
	char *x_to;      /* FIDO-Style To in News */

	/* Still unused */
	metalist_t *unknown_headers;
	metalist_t *header_garbage;

	/* Pointer auf Pufferbereich mit dem Messagetext darin */
	/* Der Speicherbereich wird von meta_clean_message nicht angerhrt */
	buf_t body;

	/* Zaehler, die von der Routine zum Anhaengen an den Body verwaltet
	 * werden.
	 */
	struct {
		unsigned long lines;
		unsigned long bytes;
		unsigned long achtbit; /* Zahl der 8bit-Zeichen */
	} bodystat;

	BOOLEAN mime_code_headers; /* Header mit q-p verschlsseln? */
	BOOLEAN mime_code_body; /* Body? */

	/* file wird *immer* in Ruhe gelassen - es ist Sache der
	 * hhergelegenen Routinen, die Datei zu schlieen.
	 * In any case message-id, envelope and/or newsgroups must be set!
	 */
	FILE *file; /* if not NULL read header and message from there */

} metamsg_t;

void 
meta_clean_message(metamsg_t *msg);

BOOLEAN 
meta_add_list(metalist_t **li, const char *text, const char *ext,int vorne);

	/* Ein metalist_t * als string schreiben. Buf sollte *gross* sein! */
int rfc_metalist2adrheader(BOOLEAN mime, char *buf,metalist_t *list);

	/* ein Element mit Kopien der beiden Strings anlegen */
metalist_t *meta_create_element(const char *text, const char *ext);

	/* Einen String an den Body anfgen. Die Zeilen muessen mit \r\n 
	 * terminiert sein.
	 */
void meta_add_to_body(metamsg_t *msg, const char *s);

	/* Eine Liste entfernen */
void meta_free_list (metalist_t **l);

void meta_free(metamsg_t *);
metamsg_t *meta_alloc(void);

#endif
